diff --git a/app/views/compute_resources_vms/index/_vmware.html.erb b/app/views/compute_resources_vms/index/_vmware.html.erb
index 7ae23128c..46ab07e26 100644
--- a/app/views/compute_resources_vms/index/_vmware.html.erb
+++ b/app/views/compute_resources_vms/index/_vmware.html.erb
@@ -12,15 +12,15 @@
   <tbody>
   <% @vms.each do |vm| %>
     <tr>
-      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity) %></td>
+      <td><%= link_to_if_authorized vm.name, hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer) %></td>
       <td><%= vm.path %></td>
       <td><%= vm.cpus %></td>
-      <td><%= number_to_human_size vm.memory %></td> 
+      <td><%= number_to_human_size vm.memory %></td>
       <td><span <%= vm_power_class(vm.ready?) %>> <%= vm_state(vm) %></span> </td>
       <td>
-        <%= action_buttons(vm_power_action(vm),
-                           show_console_action(vm.ready?, display_link_if_authorized("Console", hash_for_console_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity))),
-                           display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity))) %>
+        <%= action_buttons(vm_power_action(vm, authorizer),
+                           show_console_action(vm.ready?, display_link_if_authorized("Console", hash_for_console_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer))),
+                           display_delete_if_authorized(hash_for_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => vm.identity).merge(:auth_object => @compute_resource, :authorizer => authorizer))) %>
       </td>
 
     </tr>
diff --git a/app/views/compute_resources_vms/show.html.erb b/app/views/compute_resources_vms/show.html.erb
index 522bf7eaf..58c33e3b0 100644
--- a/app/views/compute_resources_vms/show.html.erb
+++ b/app/views/compute_resources_vms/show.html.erb
@@ -5,8 +5,8 @@
 <%
   all_actions = available_actions(@vm).push(
                   show_console_action(@vm.ready?,
-                  link_to_if_authorized(_("Console"), hash_for_console_compute_resource_vm_path, {:disabled => @vm.nil? || !@vm.ready?, :class => "btn btn-info"})),
-                  display_link_if_authorized(_("Associate VM"), hash_for_associate_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => @vm.identity), :title=> _("Associate VM to a Foreman host"), :method => :put, :class=>"btn"),
+                  link_to_if_authorized(_("Console"), hash_for_console_compute_resource_vm_path.merge(:auth_object => @compute_resource), {:disabled => @vm.nil? || !@vm.ready?, :class => "btn btn-info"})),
+                  display_link_if_authorized(_("Associate VM"), hash_for_associate_compute_resource_vm_path(:compute_resource_id => @compute_resource, :id => @vm.identity).merge(:auth_object => @compute_resource, :permission => 'edit_compute_resources'), :title=> _("Associate VM to a Foreman host"), :method => :put, :class=>"btn"),
                   link_to(_("Back"), compute_resource_path(@compute_resource), :class=>'btn btn-default'))
   title_actions *all_actions
 %>
diff --git a/app/views/config_templates/index.html.erb b/app/views/config_templates/index.html.erb
index bdc320b50..35fe4b4c8 100644
--- a/app/views/config_templates/index.html.erb
+++ b/app/views/config_templates/index.html.erb
@@ -18,11 +18,11 @@
   </tr>
   <% for config_template in @config_templates %>
     <tr>
-      <td><%= link_to_if_authorized h(config_template), hash_for_edit_config_template_path(:id => config_template.to_param) %></td>
+      <td><%= link_to_if_authorized h(config_template), hash_for_edit_config_template_path(:id => config_template.to_param).merge(:auth_object => config_template, :authorizer => authorizer, :permission => 'edit_templates') %></td>
       <td><%= combination config_template %></td>
       <td><%= config_template.try(:template_kind) %></td>
       <td><%= checked_icon config_template.snippet %></td>
-      <td><%= display_delete_if_authorized hash_for_config_template_path(:id => config_template.to_param),
+      <td><%= display_delete_if_authorized hash_for_config_template_path(:id => config_template.to_param).merge(:auth_object => config_template, :authorizer => authorizer, :permission => 'destroy_templates'),
                                            :confirm => _("Delete %s?") % config_template %> </td>
     </tr>
   <% end %>
diff --git a/app/views/domains/index.html.erb b/app/views/domains/index.html.erb
index 21114a250..cbf672b5e 100644
--- a/app/views/domains/index.html.erb
+++ b/app/views/domains/index.html.erb
@@ -10,9 +10,9 @@
   </tr>
   <% for domain in @domains %>
     <tr>
-      <td><%= link_to_if_authorized h(domain.fullname.empty? ? domain.name : domain.fullname), hash_for_edit_domain_path(:id => domain)%></td>
+      <td><%= link_to_if_authorized h(domain.fullname.empty? ? domain.name : domain.fullname), hash_for_edit_domain_path(:id => domain).merge(:auth_object => domain, :authorizer => authorizer) %></td>
       <td><%= link_to @host_counter[domain.id] || 0, hosts_path(:search => "domain = #{domain}") %>
-      <td><%= display_delete_if_authorized hash_for_domain_path(:id => domain), :confirm => _("Delete %s?") % domain.name %></td>
+      <td><%= display_delete_if_authorized hash_for_domain_path(:id => domain).merge(:auth_object => domain, :authorizer => authorizer), :confirm => _("Delete %s?") % domain.name %></td>
     </tr>
   <% end %>
 </table>
diff --git a/app/views/environments/index.html.erb b/app/views/environments/index.html.erb
index 8b156a800..cca5dda28 100644
--- a/app/views/environments/index.html.erb
+++ b/app/views/environments/index.html.erb
@@ -12,13 +12,13 @@
   <% @environments.each do |environment| %>
     <tr>
       <td>
-        <%= link_to_if_authorized environment.name, hash_for_edit_environment_path(:id => environment.name) %>
+        <%= link_to_if_authorized environment.name, hash_for_edit_environment_path(:id => environment.name).merge(:auth_object => environment, :authorizer => authorizer) %>
       </td>
       <td><%= link_to @host_counter[environment.id] || 0, hosts_path(:search => "environment = #{environment}") %>
       <td>
-        <%= action_buttons(link_to(_("Classes"), puppetclasses_path(:search => "environment = #{environment}")),
+        <%= action_buttons(link_to(_('Classes'), puppetclasses_path(:search => "environment = #{environment}")),
                            import_proxy_links(hash_for_import_environments_environments_path(:env => environment.name)),
-                           display_delete_if_authorized(hash_for_environment_path(:id => environment.name), :confirm => "Delete #{environment.name}?")) %>
+                           display_delete_if_authorized(hash_for_environment_path(:id => environment.name).merge(:auth_object => environment, :authorizer => authorizer), :confirm => "Delete #{environment.name}?")) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/filters/_form.html.erb b/app/views/filters/_form.html.erb
new file mode 100644
index 000000000..ffd4c683d
--- /dev/null
+++ b/app/views/filters/_form.html.erb
@@ -0,0 +1,69 @@
+<% javascript 'filters' %>
+
+<%= form_for @filter do |f| %>
+  <%= base_errors_for f.object %>
+  <ul class="nav nav-tabs" data-tabs="tabs">
+    <li class="active"><a href="#primary" data-toggle="tab"><%= _("Filter") %></a></li>
+    <% if show_location_tab? %>
+      <li><a href="#locations" data-toggle="tab"><%= _("Locations") %></a></li>
+    <% end %>
+    <% if show_organization_tab? %>
+      <li><a href="#organizations" data-toggle="tab"><%= _("Organizations") %></a></li>
+    <% end %>
+  </ul>
+
+  <div class="tab-content">
+
+    <div class="tab-pane active" id="primary">
+      <% if @role.present? %>
+        <%= field(f, :role_id, :label => _('Selected role')) do %>
+          <%= @role.name %>
+          <%= f.hidden_field :role_id, :value => f.object.role_id || @role.id %>
+        <% end %>
+      <% else %>
+        <%= select_f(f, :role_id, Role.scoped, :id, :name) %>
+      <% end %>
+
+      <%= selectable_f(f, :resource_type, Permission.resources_with_translations,
+                       {:include_blank => _('(Miscellaneous)')}, {:'data-url' => permissions_path}) %>
+
+      <%= multiple_selects f, :permissions, Permission.where(:resource_type => f.object.resource_type),
+                           f.object.permissions.map(&:id), :label => _("Permission") %>
+
+      <%= hidden_field_tag :role_id, @role.try(:id) %>
+
+
+      <div class="controls" id="granular_warning" style="<%= f.object.granular? ? 'display:none' : '' %>">
+          <span class="help-block">
+            <strong><%= _("Selected resource type does not support granular filtering, therefore you can't configure granularity") %></strong>
+          </span>
+      </div>
+
+      <div id="granular_form" style="<%= !f.object.granular? ? 'display:none' : '' %>">
+        <%= checkbox_f f, :unlimited?,
+                       :help_inline => _("By unchecking this you can specify filter using Foreman search syntax in search field. If filter remains unlimited (this field is checked) it applies on all resources of the selected type") %>
+
+        <%= autocomplete_f f, :search,
+                           :disabled => f.object.unlimited?,
+                           :path => resource_path(f.object.resource_type), :control_group_id => 'search_group' %>
+      </div>
+    </div>
+
+    <% if show_location_tab? %>
+      <div class="tab-pane" id="locations">
+        <% collection = User.current.locations.empty? ? Location : User.current.locations %>
+        <%= multiple_checkboxes f, :locations, f.object, collection, :label => _("Locations") %>
+      </div>
+    <% end %>
+
+    <% if show_organization_tab? %>
+      <div class="tab-pane" id="organizations">
+        <% collection = User.current.organizations.empty? ? Organization : User.current.organizations %>
+        <%= multiple_checkboxes f, :organizations, f.object, collection, {},
+                                {:label => _("Organizations")} %>
+      </div>
+    <% end %>
+  </div>
+
+  <%= submit_or_cancel f, false, :cancel_path => :back %>
+<% end %>
diff --git a/app/views/filters/edit.html.erb b/app/views/filters/edit.html.erb
new file mode 100644
index 000000000..2188e33ad
--- /dev/null
+++ b/app/views/filters/edit.html.erb
@@ -0,0 +1,3 @@
+<% title _("Edit Filter") %>
+
+<%= render 'form' %>
diff --git a/app/views/filters/index.html.erb b/app/views/filters/index.html.erb
new file mode 100644
index 000000000..70fd12549
--- /dev/null
+++ b/app/views/filters/index.html.erb
@@ -0,0 +1,48 @@
+<% title _("Filters") %>
+
+<% title_actions link_to_if_authorized(_("New filter"), hash_for_new_filter_path(:role_id => @role)) %>
+
+<table class="table table-bordered table-striped">
+  <thead>
+  <tr>
+    <% unless params[:role_id] %>
+      <th><%= sort :role, :as => _("Role") %></th>
+    <% end %>
+    <th><%= sort :resource, :as => s_("Filter|Resource") %></th>
+    <th><%= sort :search, :as => s_("Filter|Unlimited") %></th>
+    <th><%= sort :search, :as => s_("Filter|Search") %></th>
+    <th></th>
+  </tr>
+  </thead>
+  <tbody>
+  <% @filters.each do |filter| %>
+    <tr>
+      <% unless params[:role_id] %>
+        <td>
+          <%= content_tag('span', link_to_if_authorized(filter.role.name, hash_for_roles_path(:search => "name = #{filter.role.name}").
+                  merge(:auth_object => filter.role, :authorizer => @roles_authorizer))) %>
+        </td>
+      <% end %>
+      <td><%= _(filter.resource_class.try(:humanize_class_name) || filter.resource_type || '(Miscellaneous)') %></td>
+      <td><%= checked_icon filter.unlimited? %></td>
+      <td>
+        <%= content_tag('span', link_to_if_authorized(filter.search || _('none'),
+                                                      hash_for_edit_filter_path(:id => filter, :role_id => @role).
+                                                              merge(:auth_object => filter, :authorizer => authorizer))) %>
+      </td>
+      <td>
+        <%= action_buttons(
+                    display_link_if_authorized(_("Edit"), hash_for_edit_filter_path(:id => filter, :role_id => @role).
+                            merge(:auth_object => filter, :authorizer => authorizer)),
+                    display_delete_if_authorized(hash_for_filter_path(:id => filter, :role_id => @role).
+                                                         merge(:auth_object => filter, :authorizer => authorizer),
+                                                 :confirm => (_("Delete filter?")))
+            )
+        %>
+      </td>
+    </tr>
+  <% end %>
+  </tbody>
+</table>
+<%= page_entries_info @filters %>
+<%= will_paginate @filters %>
diff --git a/app/views/filters/new.html.erb b/app/views/filters/new.html.erb
new file mode 100644
index 000000000..f814bdfb5
--- /dev/null
+++ b/app/views/filters/new.html.erb
@@ -0,0 +1,3 @@
+<% title _("New Filter") %>
+
+<%= render 'form' %>
diff --git a/app/views/hostgroups/index.html.erb b/app/views/hostgroups/index.html.erb
index f72b14846..0f7761eeb 100644
--- a/app/views/hostgroups/index.html.erb
+++ b/app/views/hostgroups/index.html.erb
@@ -9,12 +9,12 @@
   </tr>
   <% @hostgroups.each do |hostgroup| %>
     <tr>
-      <td> <%= label_with_link(hostgroup) %> </td>
+      <td> <%= label_with_link(hostgroup, 1000, authorizer) %> </td>
       <td>
         <%= action_buttons(
                     display_link_if_authorized(_('Nest'),    hash_for_nest_hostgroup_path(:id => hostgroup)),
                     display_link_if_authorized(_('Clone'),   hash_for_clone_hostgroup_path(:id => hostgroup)),
-                    display_delete_if_authorized(hash_for_hostgroup_path(:id => hostgroup), :confirm => warning_message(hostgroup))) %>
+                    display_delete_if_authorized(hash_for_hostgroup_path(:id => hostgroup).merge(:auth_object => hostgroup, :authorizer => authorizer), :confirm => warning_message(hostgroup))) %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/hosts/_form.html.erb b/app/views/hosts/_form.html.erb
index dafe3ad34..60af4466f 100644
--- a/app/views/hosts/_form.html.erb
+++ b/app/views/hosts/_form.html.erb
@@ -15,7 +15,7 @@
       <% if SETTINGS[:unattended] and @host.managed %>
         <li><a href="#network" data-toggle="tab"><%= _('Network') %></a></li>
         <li><a href="#os" data-toggle="tab"><%= _('Operating System') %></a></li>
-        <% if authorized_for("Compute::Resources::Vms", :create) %>
+        <% if authorized_for(:controller => "Compute::Resources::Vms", :action => :create) %>
           <li id="compute_resource_tab" <%= display? !(@host.compute_resource_id  || params[:host] && params[:host][:compute_resource_id].present?)%>><a href="#compute_resource" data-toggle="tab"><%= _('Virtual Machine') %></a></li>
         <% end %>
       <% end %>
@@ -30,7 +30,7 @@
 
         <% if show_organization_tab?  %>
           <%= select_f f, :organization_id, Organization.my_organizations, :id, :to_label,
-            { :include_blank => !@host.managed?, :selected => @organization.id},
+            { :include_blank => !@host.managed?, :selected => @organization.try(:id)},
             { :disabled => !@host.new_record?,
               :onchange => 'organization_changed(this);', :label => _("Organization"), :'data-host-id' => @host.id,
             :'data-url' => process_taxonomy_hosts_path,
@@ -39,7 +39,7 @@
 
         <% if show_location_tab? %>
           <%= select_f f, :location_id, Location.my_locations, :id, :to_label,
-            { :include_blank => !@host.managed?, :selected => @location.id },
+            { :include_blank => !@host.managed?, :selected => @location.try(:id) },
             { :disabled => !@host.new_record?,
               :onchange => 'location_changed(this);', :label => _("Location"), :"data-host-id" => @host.id,
               :'data-url' => process_taxonomy_hosts_path, :selected => Location.my_locations,
@@ -52,7 +52,7 @@
             :'data-url' => (@host.new_record? || @host.type_changed?) ? process_hostgroup_hosts_path : hostgroup_or_environment_selected_hosts_path,
             :help_inline => :indicator } %>
 
-        <%= select_f f, :compute_resource_id, ComputeResource.my_compute_resources.with_taxonomy_scope_override(@location,@organization), :id, :to_label,
+        <%= select_f f, :compute_resource_id, ComputeResource.with_taxonomy_scope_override(@location,@organization).authorized(:view_compute_resources), :id, :to_label,
           { :include_blank => _('Bare Metal') },
           {:label => _('Deploy on'), :disabled => !@host.new_record?, :'data-url' => compute_resource_selected_hosts_path,
             :onchange => 'computeResourceSelected(this);',
diff --git a/app/views/hosts/_list.html.erb b/app/views/hosts/_list.html.erb
index c63b53f5f..09a6e2fe4 100644
--- a/app/views/hosts/_list.html.erb
+++ b/app/views/hosts/_list.html.erb
@@ -20,13 +20,13 @@
       <td class="hidden-xs"><%= (icon(host.os, :size => "18x18") + trunc(" #{host.os.to_label}",14)).html_safe if host.os %></td>
       <td class="hidden-xs"><%= trunc(host.try(:environment), 14) %></td>
       <td class="hidden-tablet hidden-xs ellipsis"><%= model_name host %></td>
-      <td class="hidden-tablet hidden-xs ellipsis"><%= label_with_link host.hostgroup, 26 %></td>
+      <td class="hidden-tablet hidden-xs ellipsis"><%= label_with_link host.hostgroup, 26, @hostgroup_authorizer %></td>
       <td class="hidden-tablet hidden-xs"><%= last_report_column(host) %></td>
       <td>
         <%= action_buttons(
-                    display_link_if_authorized(_("Edit"), hash_for_edit_host_path(:id => host)),
-                    display_link_if_authorized(_("Clone"), hash_for_clone_host_path(:id => host)),
-                    display_delete_if_authorized(hash_for_host_path(:id => host), :confirm => _("Delete %s?") % host.name, :action => :destroy))%>
+                    display_link_if_authorized(_("Edit"), hash_for_edit_host_path(:id => host).merge(:auth_object => host, :authorizer => authorizer)),
+                    display_link_if_authorized(_("Clone"), hash_for_clone_host_path(:id => host).merge(:auth_object => host, :authorizer => authorizer)),
+                    display_delete_if_authorized(hash_for_host_path(:id => host).merge(:auth_object => host, :authorizer => authorizer), :confirm => _("Delete %s?") % host.name, :action => :destroy))%>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/hosts/_provisioning.html.erb b/app/views/hosts/_provisioning.html.erb
index f53bb5364..93de4ae22 100644
--- a/app/views/hosts/_provisioning.html.erb
+++ b/app/views/hosts/_provisioning.html.erb
@@ -3,7 +3,7 @@
   <% templates.sort{|t,x| t.template_kind <=> x.template_kind}.each do |tmplt| %>
       <div class="form-group">
         <div class="control-label col-md-4"> <%= _("%s Template") % tmplt.template_kind %> </div>
-        <%= link_to_if_authorized h(tmplt), hash_for_edit_config_template_path(:id => tmplt.to_param), :rel=>"external" %>
+        <%= link_to_if_authorized h(tmplt), hash_for_edit_config_template_path(:id => tmplt.to_param, :auth_object => tmplt, :permission => 'edit_templates'), :rel=>"external" %>
       </div>
   <% end %>
 </div>
diff --git a/app/views/hosts/edit.html.erb b/app/views/hosts/edit.html.erb
index a1dcd5927..3e4277a6f 100644
--- a/app/views/hosts/edit.html.erb
+++ b/app/views/hosts/edit.html.erb
@@ -1,9 +1,9 @@
 <% title(_("Edit %s") % @host) %>
 <% if SETTINGS[:unattended] %>
   <% title_actions display_link_if_authorized((@host.managed? ? _("Unmanage host") : _("Manage host")),
-    hash_for_toggle_manage_host_path(:id => @host.name), {:method => :put}),
+    hash_for_toggle_manage_host_path(:id => @host.name).merge(:auth_object => @host, :permission => 'edit_hosts'), {:method => :put}),
     display_link_if_authorized(_("Disassociate host"),
-    hash_for_disassociate_host_path(:id => @host.name), :method => :put) %>
+    hash_for_disassociate_host_path(:id => @host.name).merge(:auth_object => @host, :permission => 'edit_hosts'), :method => :put) %>
 <% end %>
 
 <%= render :partial => 'hosts/form' %>
diff --git a/app/views/lookup_keys/index.html.erb b/app/views/lookup_keys/index.html.erb
index 949762588..6f3917719 100644
--- a/app/views/lookup_keys/index.html.erb
+++ b/app/views/lookup_keys/index.html.erb
@@ -11,11 +11,12 @@
 
 <% @lookup_keys.each do |lookup_key| %>
   <tr>
-    <td><%= link_to_if_authorized h(lookup_key.key), hash_for_edit_lookup_key_path(:id => lookup_key) %></td>
+    <td><%= link_to_if_authorized h(lookup_key.key), hash_for_edit_lookup_key_path(:id => lookup_key).merge(:auth_object => lookup_key, :permission => 'edit_external_variables', :authorizer => authorizer) %></td>
     <% puppet_class = lookup_key.param_class %>
-    <td><%= link_to_if_authorized h(puppet_class), hash_for_edit_puppetclass_path(:id => puppet_class) if puppet_class %></td>
+    <td><%= link_to_if_authorized h(puppet_class), hash_for_edit_puppetclass_path(:id => puppet_class).merge(:auth_object => puppet_class, :authorizer => @puppetclass_authorizer) if puppet_class %></td>
     <td><%=h lookup_key.lookup_values.count %></td>
-    <td><%= display_delete_if_authorized hash_for_lookup_key_path(:id => lookup_key), :confirm => _("Delete %s?") % lookup_key.key %></td>
+    <td><%= display_delete_if_authorized hash_for_lookup_key_path(:id => lookup_key).merge(:auth_object => lookup_key, :permission => 'destroy_external_variables', :authorizer => authorizer),
+                                         :confirm => _("Delete %s?") % lookup_key.key %></td>
   </tr>
 <% end %>
 </table>
diff --git a/app/views/media/index.html.erb b/app/views/media/index.html.erb
index b831f6500..54f2aa41c 100644
--- a/app/views/media/index.html.erb
+++ b/app/views/media/index.html.erb
@@ -12,12 +12,13 @@
   </tr>
   <% for medium in @media %>
     <tr>
-      <td><%= link_to_if_authorized medium, hash_for_edit_medium_path(:id => medium.id) %></td>
+      <td><%= link_to_if_authorized medium, hash_for_edit_medium_path(:id => medium.id).merge(:auth_object => medium, :authorizer => authorizer) %></td>
       <td><%= medium.path %></td>
       <td><%= lookup_family(medium.os_family) %></td>
       <td><%= medium.operatingsystems.map(&:to_label).to_sentence %></td>
       <td>
-        <%= display_delete_if_authorized hash_for_medium_path(:id => medium), :confirm => _("Delete %s?") % medium.name %>
+        <%= display_delete_if_authorized hash_for_medium_path(:id => medium).merge(:auth_object => medium, :authorizer => authorizer),
+                                         :confirm => _("Delete %s?") % medium.name %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/models/index.html.erb b/app/views/models/index.html.erb
index 4d889023f..3da369cb3 100644
--- a/app/views/models/index.html.erb
+++ b/app/views/models/index.html.erb
@@ -12,12 +12,13 @@
   </tr>
   <% for model in @models %>
     <tr>
-      <td><%=link_to_if_authorized h(model.name), hash_for_edit_model_path(:id => model)%></td>
+      <td><%=link_to_if_authorized h(model.name), hash_for_edit_model_path(:id => model).merge(:auth_object => model, :authorizer => authorizer) %></td>
       <td><%=h(model.vendor_class)%></td>
       <td><%=h(model.hardware_model)%></td>
       <td class="ra"><%= link_to @host_counter[model.id] || 0, hosts_path(:search => "model = \"#{model}\"") %></td>
       <td class="ra">
-        <%= display_delete_if_authorized hash_for_model_path(:id => model), :confirm => _("Delete %s?") % model.name %>
+        <%= display_delete_if_authorized hash_for_model_path(:id => model).merge(:auth_object => model, :authorizer => authorizer),
+                                         :confirm => _("Delete %s?") % model.name %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/operatingsystems/index.html.erb b/app/views/operatingsystems/index.html.erb
index b5ca2cb65..e76786534 100644
--- a/app/views/operatingsystems/index.html.erb
+++ b/app/views/operatingsystems/index.html.erb
@@ -9,10 +9,11 @@
   </tr>
   <% for operatingsystem in @operatingsystems %>
     <tr>
-      <td><%= link_to_if_authorized(os_name(operatingsystem), hash_for_edit_operatingsystem_path(:id => operatingsystem.id)) %></td>
+      <td><%= link_to_if_authorized(os_name(operatingsystem), hash_for_edit_operatingsystem_path(:id => operatingsystem.id).merge(:auth_object => operatingsystem, :authorizer => authorizer)) %></td>
       <td class="ra"><%= link_to @host_counter[operatingsystem.id] || 0, hosts_path(:search => "os = #{operatingsystem.name}") %></td>
       <td class="ra">
-        <%= display_delete_if_authorized hash_for_operatingsystem_path(:id => operatingsystem), :confirm => _("Delete %s?") % operatingsystem.fullname %>
+        <%= display_delete_if_authorized hash_for_operatingsystem_path(:id => operatingsystem).merge(:auth_object => operatingsystem, :authorizer => authorizer),
+                                         :confirm => _("Delete %s?") % operatingsystem.fullname %>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/permissions/index.js.erb b/app/views/permissions/index.js.erb
new file mode 100644
index 000000000..6ebf4a74c
--- /dev/null
+++ b/app/views/permissions/index.js.erb
@@ -0,0 +1,20 @@
+var permissions = $('#filter_permission_ids');
+permissions.html("<%= escape_javascript(options_for_select(@permissions.map {|p| [p.name, p.id] })) %>");
+permissions.multiSelect('refresh');
+
+var search = $('#search');
+var path = '<%= escape_javascript(@search_path) %>'
+search.attr('data-url', path);
+search.val('');
+search.catcomplete({source: function( request, response ) {
+    $.getJSON( search.attr('data-url'), { search: request.term }, response );
+}})
+
+<% if @granular %>
+  $('#granular_warning').hide();
+  $('#granular_form').show();
+<% else %>
+  $('#granular_warning').show();
+  $('#granular_form').hide();
+  $('#filter_unlimited').prop('checked', true);
+<% end %>
diff --git a/app/views/ptables/index.html.erb b/app/views/ptables/index.html.erb
index 2d87ba862..7df75bd8d 100644
--- a/app/views/ptables/index.html.erb
+++ b/app/views/ptables/index.html.erb
@@ -10,11 +10,11 @@
   </tr>
   <% for ptable in @ptables %>
     <tr>
-      <td><%= link_to_if_authorized ptable, hash_for_edit_ptable_path(:id => ptable.id) %></td>
+      <td><%= link_to_if_authorized ptable, hash_for_edit_ptable_path(:id => ptable.id).merge(:auth_object => ptable, :authorizer => authorizer) %></td>
       <td><%= lookup_family(ptable.os_family) %></td>
       <td><%= ptable.operatingsystems.map(&:to_label).to_sentence %></td>
       <td>
-        <%= display_delete_if_authorized hash_for_ptable_path(:id => ptable), :confirm => _("Delete %s?") % ptable.name%>
+        <%= display_delete_if_authorized hash_for_ptable_path(:id => ptable).merge(:auth_object => ptable, :authorizer => authorizer), :confirm => _("Delete %s?") % ptable.name%>
       </td>
     </tr>
   <% end %>
diff --git a/app/views/puppetclasses/_class_selection.html.erb b/app/views/puppetclasses/_class_selection.html.erb
index 02149f7f0..173fdcefe 100644
--- a/app/views/puppetclasses/_class_selection.html.erb
+++ b/app/views/puppetclasses/_class_selection.html.erb
@@ -8,7 +8,7 @@
     <%# hidden field to ensure that classes gets removed if none are defined %>
     <%= hidden_field_tag obj.class.model_name.downcase + "[puppetclass_ids][]" %>
     <ul id="selected_classes">
-      <% if authorized_for(:host_editing, :edit_classes) %>
+      <% if authorized_for(:controller => :host_editing, :action => :edit_classes) %>
         <%= render :partial => "puppetclasses/selectedClasses",
           :collection => obj.puppetclasses ,:as => :klass,
           :locals => { :type => obj.class.model_name.downcase, :host => obj } %>
diff --git a/app/views/puppetclasses/_classes.html.erb b/app/views/puppetclasses/_classes.html.erb
index 0cc36b880..d6ca1c9e9 100644
--- a/app/views/puppetclasses/_classes.html.erb
+++ b/app/views/puppetclasses/_classes.html.erb
@@ -6,7 +6,7 @@
         <li><%= link_to_function image_tag("bullet_toggle_plus.png") + " " + list.first, "$('#pc_#{list.first}').fadeToggle('slow')" %>
           <ul id="pc_<%= list.first %>" style="display: none;">
             <% for klass in list.last.sort %>
-              <% unless authorized_for(:host_editing, :edit_classes) %>
+              <% unless authorized_for(:controller => :host_editing, :action => :edit_classes) %>
                 <li data-original-title="<%= _('Not authorized to edit classes') %>" rel="twipsy"><%= h klass.name %></li>
               <% else %>
                 <% style = selected_puppet_classes.include?(klass) ? "hide" : "" %>
diff --git a/app/views/puppetclasses/index.html.erb b/app/views/puppetclasses/index.html.erb
index 0c56343b9..95273a381 100644
--- a/app/views/puppetclasses/index.html.erb
+++ b/app/views/puppetclasses/index.html.erb
@@ -13,17 +13,18 @@
   </tr>
   <% for puppetclass in @puppetclasses %>
     <tr>
-      <td><%=link_to_if_authorized h(puppetclass.name), hash_for_edit_puppetclass_path(:id => puppetclass) %></td>
+      <td><%=link_to_if_authorized h(puppetclass.name), hash_for_edit_puppetclass_path(:id => puppetclass).merge(:auth_object => puppetclass, :authorizer => authorizer) %></td>
       <td>
         <% puppetclass.environments.uniq.each do |environment| %>
           <%= link_to_function environment, 'show_rdoc(this)', :'data-url' => rdoc_classes_path(environment, puppetclass.name) %>
         <% end %>
       </td>
-      <td><%= puppetclass.hostgroups.map {|hg| link_to_if_authorized hg, hash_for_edit_hostgroup_path(:id=>hg)}.to_sentence.html_safe %></td>
+      <td><%= puppetclass.hostgroups.map {|hg| link_to_if_authorized hg, hash_for_edit_hostgroup_path(:id=>hg).merge(:auth_object => hg, :authorizer => @hostgroups_authorizer)}.to_sentence.html_safe %></td>
       <td> <%= link_to host_counter(puppetclass), hosts_path(:search => "class = #{puppetclass.name}")%></td>
       <td><%= @keys_counter[puppetclass.name] || 0 %> </td>
       <td>
-        <%= display_delete_if_authorized hash_for_puppetclass_path(:id => puppetclass), :confirm => _("Delete %s?") % puppetclass.name %>
+        <%= display_delete_if_authorized hash_for_puppetclass_path(:id => puppetclass).merge(:auth_object => puppetclass, :authorizer => authorizer),
+                                         :confirm => _("Delete %s?") % puppetclass.name %>
       </td>
     </tr>
   <% end %>
